﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace KxxRLSample
{
    public partial class DevForm : Form
    {
        public short DevId;     //Device Id

        private Boolean ChangeEn;       // リレー操作の可不可
        private byte[] DOUTStatus = new byte[2];    //Digital Output Status
        //チェックボックスコントロール用配列を作成
        private System.Windows.Forms.CheckBox[] RLOUT;
        //ラベルコントロール用配列を作成
        private System.Windows.Forms.Label[] RLST;

        public DevForm()
        {
            InitializeComponent();
            //チェックボックスのインスタンスを配列にコピーして配列化する
            this.RLOUT = new System.Windows.Forms.CheckBox[]
                {this.RLOUT0, this.RLOUT1, this.RLOUT2, this.RLOUT3,
                this.RLOUT4, this.RLOUT5, this.RLOUT6, this.RLOUT7};
            //ラベルコントロールのインスタンスを配列にコピーして配列化する
            this.RLST = new System.Windows.Forms.Label[]
                {this.RLST0, this.RLST1, this.RLST2, this.RLST3,
                this.RLST4, this.RLST5, this.RLST6, this.RLST7};
        }

        // check bit
        // bit -> 0~7
        private Boolean BitCheck(byte Data, int bit)
        {
            return ((Data & (1 << bit)) != 0);
        }

        public void SetId(short Id)
        {
            short retErr;
            byte Bit;
            byte Data;

            DevId = Id;

            this.Text = "ID = " + DevId.ToString() + "  Panel";

            retErr = TUSBKRL.TUSBKRL_Read(DevId, out Data);
            if( retErr != 0 )
            {
                MessageBox.Show(TUSBKRL.GetErrMessage(retErr));
                this.Close();
                return;
            }

            ChangeEn = false;
            for (Bit = 0; Bit < 8; Bit++)
                RLOUT[Bit].Checked = BitCheck(Data, Bit);
            ChangeEn = true;

            IoCheck();

            Timer1.Interval = 100;
            Timer1.Enabled = true;
        }

        private void IoCheck()
        {
            short retErr;
            byte Data;
            short Bit;

            retErr = TUSBKRL.TUSBKRL_Read(DevId, out Data);

            for( Bit = 0 ; Bit < 8 ; Bit ++ )
            {
                RLST[Bit].Text = BitCheck(Data, Bit) ? "On" : "Off";
            }
        }

        private void RLOUT_Changed()
        {
            short retErr;
            int index;
            byte tmpB;

            tmpB = 0;

            for (index = 0; index < 8; index++)
            {
                if (RLOUT[index].CheckState == CheckState.Checked)
                    tmpB += (byte)(1 << index);
            }

            retErr = TUSBKRL.TUSBKRL_Set(DevId, tmpB);

            if (retErr != 0)
                MessageBox.Show(TUSBKRL.GetErrMessage(retErr));
        }

        private void RLOUT_CheckStateChanged(object sender, EventArgs e)
        {
            if( ChangeEn )
                RLOUT_Changed();
        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            IoCheck();
        }
    }
}
