﻿Public Class DevForm
    Inherits System.Windows.Forms.Form

    Private DevId As Integer         'Device Id

    Private ChangeEn As Boolean     'リレー操作の可不可
    Private DOUTStatus(1) As Byte    'Digital Output Status
    'チェックボックスコントロール用配列を作成
    Private RLOUT() As System.Windows.Forms.CheckBox
    'ラベルコントロール用配列を作成
    Private RLST() As System.Windows.Forms.Label

    ' check bit set
    ' bit -> 0~7
    Private Function BitCheck(ByVal Data As Byte, ByVal bit As Integer) As Boolean
        Return ((Data And (1 << bit)) <> 0)
    End Function

    'This Form module initialize
    Public Sub SetId(ByVal Id As Short)
        Dim retErr As Short
        Dim Bit As Byte
        Dim Data As Byte

        DevId = Id

        Me.Text = "ID = " + DevId.ToString() + "  Panel"

        retErr = TUSBKRL_Read(DevId, Data)
        If retErr Then
            TUSBKRL_ErrorDisp(retErr)
            Me.Close()
            Exit Sub
        End If

        ChangeEn = False
        For Bit = 0 To 7
            RLOUT(Bit).Checked = BitCheck(Data, Bit)
        Next Bit
        ChangeEn = True

        IoCheck()

        Timer1.Interval = 100
        Timer1.Enabled = True
    End Sub

    Public Sub New()

        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。
        'チェックボックスのインスタンスを配列にコピーして配列化する
        Me.RLOUT = New System.Windows.Forms.CheckBox() _
            {Me.RLOUT0, Me.RLOUT1, Me.RLOUT2, Me.RLOUT3, _
            Me.RLOUT4, Me.RLOUT5, Me.RLOUT6, Me.RLOUT7}
        'ラベルコントロールのインスタンスを配列にコピーして配列化する
        Me.RLST = New System.Windows.Forms.Label() _
            {Me.RLST0, Me.RLST1, Me.RLST2, Me.RLST3, _
            Me.RLST4, Me.RLST5, Me.RLST6, Me.RLST7}
    End Sub

    Private Sub IoCheck()
        Dim retErr As Short
        Dim Data As Byte
        Dim Bit As Short

        retErr = TUSBKRL_Read(DevId, Data)
        If retErr Then
            TUSBKRL_ErrorDisp(retErr)
            Me.Close()
            Exit Sub
        End If

        For Bit = 0 To 7
            RLST(Bit).Text = IIf(BitCheck(Data, Bit), "On", "Off")
        Next Bit
    End Sub

    Private Sub RLOUT_Changed()
        Dim retErr As Short
        Dim index As Integer
        Dim tmpB As Byte

        tmpB = 0

        For index = 0 To 7
            If RLOUT(index).CheckState = CheckState.Checked Then
                tmpB += (1 << index)
            End If
        Next

        retErr = TUSBKRL_Set(DevId, tmpB)

        If retErr Then
            TUSBKRL_ErrorDisp(retErr)
        End If
    End Sub

    Private Sub RLOUT_CheckStateChanged(sender As System.Object, e As System.EventArgs) Handles RLOUT7.CheckStateChanged, RLOUT6.CheckStateChanged, RLOUT5.CheckStateChanged, RLOUT4.CheckStateChanged, RLOUT3.CheckStateChanged, RLOUT2.CheckStateChanged, RLOUT1.CheckStateChanged, RLOUT0.CheckStateChanged
        If ChangeEn Then
            RLOUT_Changed()
        End If
    End Sub

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        IoCheck()
    End Sub
End Class